-- MySQL dump 9.11
--
-- Host: localhost    Database: prometeus
-- ------------------------------------------------------
-- Server version	4.0.21-log

--
-- Table structure for table `bugs`
--

CREATE TABLE bugs (
  rpm varchar(100) binary NOT NULL default '',
  bug_id mediumint(8) unsigned NOT NULL default '0',
  severety enum('enhancement','trivial','minor','normal','major','critical','blocker') NOT NULL default 'enhancement',
  priority enum('P1','P2','P3','P4','P5') NOT NULL default 'P1',
  assigned varchar(20) NOT NULL default '',
  reporter varchar(50) NOT NULL default '',
  status enum('UNCONFIRMED','NEW','ASSIGNED','REOPENED','RESOLVED','VERIFIED','CLOSED') NOT NULL default 'UNCONFIRMED',
  resolution enum('FIXED','INVALID','WONTFIX','LATER','REMIND','DUPLICATE','WORKSFORME','MOVED') default NULL,
  description varchar(255) default NULL,
  PRIMARY KEY  (bug_id),
  KEY rpm (rpm(20))
) TYPE=MyISAM;

--
-- Table structure for table `changelogs`
--

CREATE TABLE changelogs (
  rpm varchar(100) binary NOT NULL default '',
  time date NOT NULL default '0000-00-00',
  packager varchar(20) default NULL,
  version varchar(100) default NULL,
  name varchar(100) NOT NULL default '',
  content text,
  PRIMARY KEY  (rpm,time,name),
  KEY rpm (rpm),
  KEY packager (packager)
) TYPE=MyISAM;

--
-- Table structure for table `counter`
--

CREATE TABLE counter (
  ip varchar(15) NOT NULL default '',
  time datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (ip)
) TYPE=MyISAM;

INSERT INTO counter VALUES ('127.0.0.1','2005-01-01 12:00:00');

--
-- Table structure for table `discussion`
--

CREATE TABLE discussion (
  srpm varchar(100) binary NOT NULL default '',
  id int(11) unsigned NOT NULL auto_increment,
  pid int(11) unsigned NOT NULL default '0',
  tid int(11) unsigned NOT NULL default '0',
  time datetime NOT NULL default '0000-00-00 00:00:00',
  reply varchar(100) default NULL,
  message text NOT NULL,
  uid int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (srpm,id)
) TYPE=MyISAM;

--
-- Table structure for table `fcookie`
--

CREATE TABLE fcookie (
  uid mediumint(8) unsigned NOT NULL default '0',
  srpm varchar(100) binary NOT NULL default '',
  id mediumint(8) unsigned NOT NULL default '0',
  ans mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (uid,srpm,id)
) TYPE=MyISAM;

--
-- Table structure for table `groups`
--

CREATE TABLE groups (
  id mediumint(8) unsigned NOT NULL auto_increment,
  rpmgroup varchar(100) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

--
-- Table structure for table `maintainers`
--

CREATE TABLE maintainers (
  mail varchar(20) NOT NULL default '',
  packager varchar(255) default NULL,
  type enum('man','team') NOT NULL default 'man',
  PRIMARY KEY  (mail)
) TYPE=MyISAM;

--
-- Table structure for table `members`
--

CREATE TABLE members (
  mail varchar(20) NOT NULL default '',
  packager varchar(255) default NULL,
  sirname varchar(50) default NULL,
  name varchar(50) default NULL,
  o varchar(50) default NULL,
  info text,
  work text,
  born date default NULL,
  city varchar(60) default NULL,
  country varchar(50) default NULL,
  photo mediumblob,
  PRIMARY KEY  (mail)
) TYPE=MyISAM;

--
-- Table structure for table `mirrors`
--

CREATE TABLE mirrors (
  mirror varchar(255) NOT NULL default ''
) TYPE=MyISAM;

--
-- Table structure for table `rpm`
--

CREATE TABLE rpm (
  srpm varchar(100) binary NOT NULL default '',
  name varchar(100) binary NOT NULL default '',
  version varchar(100) NOT NULL default '',
  release varchar(100) NOT NULL default '',
  rpmgroup mediumint(8) unsigned NOT NULL default '0',
  size int(11) NOT NULL default '0',
  summary varchar(255) NOT NULL default '',
  description text NOT NULL,
  optflags varchar(255) default NULL,
  PRIMARY KEY  (name),
  KEY srpm (srpm)
) TYPE=MyISAM;

--
-- Table structure for table `spec`
--

CREATE TABLE spec (
  rpm varchar(100) binary NOT NULL default '',
  spec mediumtext,
  PRIMARY KEY  (rpm)
) TYPE=MyISAM;

--
-- Table structure for table `srpm`
--

CREATE TABLE srpm (
  name varchar(100) binary NOT NULL default '',
  version varchar(100) NOT NULL default '',
  release varchar(100) NOT NULL default '',
  rpmgroup mediumint(8) unsigned NOT NULL default '0',
  packager varchar(20) NOT NULL default '',
  buildtime datetime NOT NULL default '0000-00-00 00:00:00',
  size int(11) NOT NULL default '0',
  summary varchar(255) NOT NULL default '',
  description text NOT NULL,
  url varchar(255) default NULL,
  copyright varchar(100) default NULL,
  age mediumint(8) unsigned default '1',
  PRIMARY KEY  (name),
  KEY packager (packager)
) TYPE=MyISAM;

--
-- Table structure for table `teams`
--

CREATE TABLE teams (
  mail varchar(20) NOT NULL default '',
  name varchar(255) default NULL,
  members text NOT NULL,
  info text,
  PRIMARY KEY  (mail)
) TYPE=MyISAM;

--
-- Table structure for table `topic`
--

CREATE TABLE topic (
  srpm varchar(100) binary NOT NULL default '',
  id int(11) unsigned NOT NULL auto_increment,
  time datetime NOT NULL default '0000-00-00 00:00:00',
  header varchar(100) NOT NULL default '',
  message text NOT NULL,
  reads int(11) unsigned NOT NULL default '0',
  answs int(11) unsigned NOT NULL default '0',
  uid int(11) unsigned NOT NULL default '0',
  lasttime datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (srpm,id),
  KEY srpm (srpm,lasttime)
) TYPE=MyISAM;

--
-- Table structure for table `userprefs`
--

CREATE TABLE userprefs (
  uid mediumint(8) unsigned NOT NULL default '0',
  rpm varchar(100) binary NOT NULL default '',
  version varchar(200) NOT NULL default '',
  bugscount mediumint(8) unsigned NOT NULL default '0',
  type enum('bookmark','pref','all') NOT NULL default 'bookmark',
  PRIMARY KEY  (uid,rpm)
) TYPE=MyISAM;

--
-- Table structure for table `users`
--

CREATE TABLE users (
  uid mediumint(8) unsigned NOT NULL auto_increment,
  nick varchar(50) NOT NULL default '',
  pass varchar(50) binary default NULL,
  email varchar(50) default NULL,
  info text,
  karma mediumint(9) NOT NULL default '0',
  session varchar(15) NOT NULL default '',
  time datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (uid)
) TYPE=MyISAM;

--
-- Table structure for table `visit`
--

CREATE TABLE visit (
  val int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;

INSERT INTO visit VALUES (1);
