#!/usr/bin/perl
#
# script:       addmess.pl
# description:     
# author:       Vladimir Lettiev aka crux <crux@altlinux.ru> (c) 2004
# version:      0.1

use strict;
use CGI qw/param cookie/;
use DBI;
use FindBin qw($Bin);
use lib "$Bin/adm";
use altbase;

#> My constants
my ($select_Q,@row,$row,$sth,$dbh,$text,$session,$cookie);
my $status = "";
my ($nick,$uid) = (undef,undef);
my $ret_page = "/";
my $cgi = new CGI;
my $alt = new altbase;

unless ($cgi->param && $ENV{"REQUEST_METHOD"} eq "POST"){
    print $altbase::header . "error: addmess.pl:24";
    exit;
}

my $topic = $cgi->param('topic');
my $mess  = $cgi->param('mess');
my $pid   = $cgi->param('pid');
my $sid   = $cgi->param('sid');
my $srpm  = $cgi->param('srpm');

#> Connection to MySQL
$dbh = DBI->connect($altbase::dsn,$altbase::dbUser,$altbase::dbPass);

my $session = cookie('ses');

#    
if (defined($session) && length($session) == 15 && $session =~ /^\w+$/) {
    my $selectName_Q = "SELECT nick,uid FROM users WHERE session=? AND (UNIX_TIMESTAMP(NOW()) - UNIX_TIMESTAMP(time)) < ?";
    $sth = $dbh->prepare($selectName_Q);
    $sth->execute($session,$altbase::TTL);
    ($nick,$uid) = $sth-> fetchrow_array;
    if ($nick) {
        my $updateTime_Q = "UPDATE users SET time=NOW() WHERE session=?";
        $sth = $dbh->prepare($updateTime_Q);
        $sth->execute($session);
    }
    $sth->finish();
}
						    
#     srpm-
if (defined($srpm) && $srpm =~ /^[\w\.\-\+]+$/ ) {

    my $checkSRPM_Q = "select count(*) FROM srpm where name=?";
    $sth = $dbh->prepare($checkSRPM_Q);
    $sth->execute($srpm);
    $row = $sth->fetchrow_array();
    if ($row != 1) {
	$srpm = undef;    
    }

} else {
    $srpm = undef;
}

#    pid 
if (! defined($pid) || $pid =~ /\D/) {
    $pid = undef;
}

#    sid 
if (! defined($sid) || $sid =~ /\D/) {
    $sid = undef;
}

#  
if ($topic eq ""){
    $topic = $alt->messages("emptyTopic");
}

#   
if (length($mess) > 65535){
    $mess = substr($srpm,0,65535);
}

# ,    
unless (defined($srpm) && defined($nick) && $mess ne "") {
    print $altbase::header . $alt->messages("paramError");
    exit;
}

$ret_page = "/forum/".$srpm;

# answer
if (defined($pid) || defined($sid)){

    if (defined($sid)) {
	my $checkTop_Q = "SELECT tid FROM discussion WHERE id=?";
	$sth = $dbh->prepare($checkTop_Q);
	$sth->execute($sid);
	$pid = $sth->fetchrow_array;
	$sth->finish();
    } else {
	my $checkPid_Q = "SELECT count(*) FROM topic WHERE id=?";
	$sth = $dbh->prepare($checkPid_Q);
	$sth->execute($pid);
	$row = $sth->fetchrow_array;
	$sth->finish();
	$pid = undef unless $row;
	$sid = 0;
    }

    if ($pid) {
        my $insAns_Q = "INSERT discussion VALUES(?,'',?,?,NOW(),?,?,?)";
        $sth = $dbh->prepare($insAns_Q);
	$sth->execute($srpm,$sid,$pid,$topic,$mess,$uid);
        $ret_page .= "/".$pid.".html";

	my $updTopAns_Q = "UPDATE topic SET answs=answs+1, lasttime=NOW() WHERE id=?";
	$sth = $dbh->prepare($updTopAns_Q);
	$sth->execute($pid);
	$sth->finish();
    }

# new topic
} else {
    my $insTopic_Q = "INSERT topic VALUES(?,'',NOW(),?,?,0,0,?,NOW())";
    $sth = $dbh->prepare($insTopic_Q);
    $sth->execute($srpm,$topic,$mess,$uid);
    $sth->finish();
}

$dbh->disconnect();

print $altbase::redirect . $altbase::path . $ret_page . $status . "\n\n";
