#!/usr/bin/perl
#
# script:       auth.pl
# description:  authorization & registration of user accounts
# author:       Vladimir Lettiev aka crux <crux@altlinux.ru> (c) 2004
# version:      0.1

use strict;
use CGI qw/param cookie/;
use DBI;
use FindBin qw($Bin);
use lib "$Bin/adm";
use altbase;

#> My constants
my ($select_Q,@row,$row,$sth,$dbh,$text,$session,$cookie);
my $status = "";
my $ret_page = "/auth?status=";
my $cgi = new CGI;
my $alt = new altbase;

unless ($cgi->param && $ENV{"REQUEST_METHOD"} eq "POST"){
    print $altbase::redirect . $altbase::path . "/auth/?status=badmethod\n\n";
    exit;
}

my $login = $cgi->param('login');
my $pass1 = $cgi->param('pass');
my $pass2 = $cgi->param('pass2');
my $go    = $cgi->param('go');

unless (defined($login) && length($login) > 1  && length($login) < 51 &&
        defined($pass1) && length($pass1) > 1  && length($pass1) < 51 && defined($go)) {
    print $altbase::redirect.$altbase::path . "/auth/?status=badparams\n\n";
    exit;
}

#> Connection to MySQL
$dbh = DBI->connect($altbase::dsn,$altbase::dbUser,$altbase::dbPass);

# registration
if ($go eq "go"){

    if ($pass1 ne "" && $pass1 eq $pass2) {
        my $selLogin_Q = "SELECT count(*) FROM users WHERE nick=?";
        $sth = $dbh->prepare($selLogin_Q);
        $sth->execute($login);
        $row = $sth->fetchrow_array;
        if ($row == 0){
            my $newUser_Q = "INSERT users VALUES('',?,?,'','','0',?,NOW())";
            $session = join '', ("a".."z","_",0..9)[map {rand 37} 0..14];
            $sth = $dbh->prepare($newUser_Q);
            $sth->execute($login,$pass1,$session);
            $cookie = cookie( -name   => "ses",
                              -value  => $session,
                              -expires=> "+1y",
                              -path   => "/"
                );
            print "Set-Cookie: $cookie\n";
            $ret_page = "/my";
        } else {
            $status = "userexists";
        }
    } else {
        $status = "badpass";
    }

# authorization
} else {

    my $checkPass_Q = "SELECT count(*) FROM users WHERE nick=? AND pass=?";
    $sth = $dbh->prepare($checkPass_Q);
    $sth->execute($login,$pass1);
    $row = $sth->fetchrow_array();
    if ($row == 1){
        $session = join '', ("a".."z","_",0..9)[map {rand 37} 0..14];
        my $updateUser_Q = "UPDATE users SET time=NOW(), session=? WHERE nick=?";
        $sth = $dbh->prepare($updateUser_Q);
        $sth->execute($session,$login);
        $cookie = cookie( -name   => "ses",
                          -value  => $session,
                          -expires=> "+1d",
                          -path   => "/"
        );
        print "Set-Cookie: $cookie\n";
        $ret_page = "/my";
    } else {
        $status = "badloginorpass";
    }
}

$dbh->disconnect();

print $altbase::redirect . $altbase::path . $ret_page . $status . "\n\n";
