#!/usr/bin/perl
#
# script:      rpmlist.pl
# description: show list of rpm sorted by time
# author:      Vladimir Lettiev aka crux <crux@altlinux.ru> (c) 2004
# version:     0.1
#

use strict;
use CGI qw/param/;
use DBI;
use FindBin qw($Bin);
use lib "$Bin/adm";
use altbase;

#> My constants
my ($select_Q,$name,$dbh,$sth,$sth2,@row);
my $text = "";
my $textNav = "";
my $ppp = 40;

my $cgi = new CGI;
my $alt = new altbase;

#> Load html fragments
if (! $alt->init(module => "inform", script => "rpmlist.pl") ){
        print $altbase::header . $altbase::errStr;
        exit;
}

my $page = $cgi->param('page');
if (! defined($page) || $page =~ /\D/ || $page < 1 || $page > $altbase::maxPage) {
    $page = 1;
}

my $start = $page*$ppp - 20;

$textNav = $alt->parser (
		HTML => "navigation",
		vars => {
		    "path" => $altbase::path,
		    "pagePrev" => $page-1,
		    "pageNext" => $page+1,
		},
		iflist => {
		    "first" => ($page == 1)?1:0
		}
	);

my $oldDate = "";
my $nowDate = "";
my $oldRpm  = "";

$select_Q = "SELECT s.name, s.version, s.release, g.id, m.packager, s.buildtime, \
    s.summary, c.content, s.packager, m.type, c.packager, s.age FROM srpm as s, \
    maintainers as m, changelogs as c, groups as g WHERE m.mail=s.packager AND g.id=s.rpmgroup \
    AND c.version=CONCAT(s.version,'-',s.release) AND c.rpm=s.name \
    ORDER by s.buildtime DESC LIMIT $start,$ppp";

$dbh = DBI->connect($altbase::dsn,$altbase::dbUser,$altbase::dbPass);

$sth = $dbh->prepare($select_Q);
$sth->execute();
while (@row = $sth->fetchrow_array){

	next if ($oldRpm eq $row[0]);
	$oldRpm = $row[0];

	if ($row[8] ne $row[10] && $row[10] ne "qa-robot") {
	    my $selBuilder_Q = "SELECT packager FROM maintainers WHERE mail=?";
	    $sth2 = $dbh->prepare($selBuilder_Q);
	    $sth2->execute($row[10]);
	    $row[12] = $sth2->fetchrow_array();
            $row[12] =~ s/\s*<.+$//;
	}

	$nowDate = MakeDate($row[5]);
	if ($nowDate ne $oldDate){
	    $text .= parser(
		HTML => "day",
		vars => {
		    "date" => $nowDate
		},
		iflist => {}
	    );
	    $oldDate = $nowDate;
	}

        $row[4] =~ s/\s*<.+$//;
        tagConv(\$row[7]);
        $text .= $alt->parser(
            HTML => ($row[8] eq $row[10])?"package":"NMUpackage",
            vars => {
                "path" => $altbase::path,
                "name" => $row[0],
                "version" => $row[1],
                "release" => $row[2],
                "group" => &localeGrp($row[3]),
                "mail" => $row[8],
                "packager" => tagClean($row[4]),
		"builder" => tagClean($row[12]),
		"buildermail" => tagClean($row[10]),
                "date" => MakeDateTime($row[5]),
                "summary" => tagClean($row[6]),
                "changes" => $row[7],
		"state" => ($row[11] > 1)?"old":"new",
            },
            iflist => {
                "team" => ($row[9] eq "team")?1:0,
		"NMU" => ($row[8] eq $row[10])?1:0,
		"qarobot" => ($row[10] eq "qa-robot")?1:0,
		"old" => ($row[11] > 1)?1:0
            }
        );
}
$dbh->disconnect();

print $altbase::header;
print $textNav.$text.$textNav;

