#!/usr/bin/perl
#
# script:      stats.pl
# description: show statictics
# author:      Vladimir Lettiev aka crux <crux@altlinux.ru> (c) 2004
# version:     0.2
#

use strict;
use CGI qw/param/;
use DBI;
use FindBin qw($Bin);
use lib "$Bin/adm";
use altbase;

#> My constants
my ($select_Q,$name,$dbh,$sth,$sth2,@row);
my $text = "";

my $cgi = new CGI;
my $alt = new altbase;

#> Load html fragments
if (! $alt->init(module => "inform", script => "stats.pl") ){
        print $altbase::header . $altbase::errStr;
        exit;
}

my $type = $cgi->param('type');

if ($type eq "leader") {
    
    $select_Q = "SELECT count(srpm.name), maintainers.packager, srpm.packager, \
    maintainers.type FROM srpm, maintainers WHERE maintainers.mail=srpm.packager AND \
    maintainers.type='man' AND srpm.age != 0 \
    GROUP BY srpm.packager ORDER BY 1 DESC LIMIT 15";

} elsif ($type eq "lastrpm") {

    $select_Q = "SELECT s.name, s.version, s.release, g.id, m.packager, s.buildtime, \
    s.summary, c.content, s.packager, m.type, c.packager, s.age FROM srpm as s, \
    maintainers as m, changelogs as c, groups as g WHERE m.mail=s.packager AND \
    g.id=s.rpmgroup AND c.version=CONCAT(s.version,'-',s.release) AND c.rpm=s.name \
    ORDER by s.buildtime DESC LIMIT 0,20";

} elsif ($type eq "activity") {
    
    $select_Q = "SELECT rpm, count(time) FROM changelogs WHERE \
    time>(DATE_SUB(NOW(),INTERVAL 6 MONTH)) GROUP BY rpm ORDER BY 2 DESC, 1 ASC LIMIT 15";

}

my $oldRpm = "";

$dbh = DBI->connect($altbase::dsn,$altbase::dbUser,$altbase::dbPass);

$sth = $dbh->prepare($select_Q);
$sth->execute();
while (@row = $sth->fetchrow_array){
    if ($type eq "lastrpm"){

	next if ($oldRpm eq $row[0]);
	$oldRpm = $row[0];

	if ($row[8] ne $row[10] && $row[10] ne "qa-robot") {
	    my $selBuilder_Q = "SELECT packager FROM maintainers WHERE mail=?";
	    $sth2 = $dbh->prepare($selBuilder_Q);
	    $sth2->execute($row[10]);
	    $row[12] = $sth2->fetchrow_array();
            $row[12] =~ s/\s*<.+$//;
	}

        $row[4] =~ s/\s*<.+$//;
        tagConv(\$row[7]);
        $text .= $alt->parser(
            HTML => ($row[8] eq $row[10])?"package":"NMUpackage",
            vars => {
                "path" => $altbase::path,
                "name" => $row[0],
                "version" => $row[1],
                "release" => $row[2],
                "group" => &localeGrp($row[3]),
                "mail" => $row[8],
                "packager" => tagClean($row[4]),
		"builder" => tagClean($row[12]),
		"buildermail" => tagClean($row[10]),
                "date" => MakeDateTime($row[5]),
                "summary" => tagClean($row[6]),
                "changes" => $row[7],
		"state" => ($row[11] > 1)?"old":"new",
            },
            iflist => {
                "team" => ($row[9] eq "team")?1:0,
		"NMU" => ($row[8] eq $row[10])?1:0,
		"qarobot" => ($row[10] eq "qa-robot")?1:0,
		"old" => ($row[11] > 1)?1:0
            }
        );
    } elsif ($type eq "leader"){
        $row[1] =~ s/\s*<.+$//;
        $text .= $alt->parser(
                    HTML => "leader",
                    vars => {
                        "path" => $altbase::path,
                        "name" => $row[2],
                        "packager" => tagClean($row[1]),
                        "count" => $row[0]
                    },
                    iflist => {}
        );
    } elsif ($type eq "activity") {
        if (length($row[0]) > 24) {
            $name = substr($row[0],0,22);
            $name .= "&hellip;";
        } else {
            $name= $row[0];
        }
        $text .= $alt->parser(
                    HTML => "activity",
                    vars => {
                        "path" => $altbase::path,
                        "name" => $row[0],
                        "display" => $name,
                        "activity" => $row[1]
                    },
                    iflist => {}
        );
    }
}

$dbh->disconnect();

print $altbase::header;
print $text;

